#include "mobile.h"
#include <stdlib.h>
#include <stdio.h>

float Mobile::rnd()
{
	double n = ((float)(rand() % 1000)) / 1000.0f;
	return (float)n;
}

Mobile::Mobile()
{

	SENSOR_BUFFER = 30000;
	tickcount = 0;
	curState = 0;
	lastIdleEvent = 5000;
	secondTimer = 0;
	dimStamp = 0;
	dimTime = 0;
	nextRapid = 0;
	nextFlick = 0;
	curHighlight = -1;
	highlightWaxing = true;
	highlightStamp = 0;
	blink = false;
	speed = 1.0f;

	m[0] = false;
	m[1] = false;
	m[2] = false;
	DNP = false;
	numSensors = 0;
	prevNumSensors = 0;
	sensorTime = 0;
	mTimer[0] = 0;
	mTimer[1] = 0;
	mTimer[2] = 0;

	keys[0] = false;
	keys[1] = false;
	keys[2] = false;
	keys[3] = false;

	dome[0].x = 512;
	dome[0].y = 512;
	dome[0].scale = 1.0f;

	dome[1].x = 619;
	dome[1].y = 232;
	dome[1].scale = 0.5f;

	dome[2].x = 617;
	dome[2].y = 727;
	dome[2].scale = 0.375f;

	dome[3].x = 94;
	dome[3].y = 745;
	dome[3].scale = 0.266f;

	dome[4].x = 736;
	dome[4].y = 421;
	dome[4].scale = 0.25f;

	dome[5].x = 375;
	dome[5].y = 629;
	dome[5].scale = 0.25f;

	dome[6].x = 927;
	dome[6].y = 423;
	dome[6].scale = 0.233f;

	dome[7].x = 402;
	dome[7].y = 462;
	dome[7].scale = 0.208f;
	/*
	dome[8].x = 632;
	dome[8].y = 253;
	dome[8].scale = 0.166f;

	dome[9].x = 646;
	dome[9].y = 731;
	dome[9].scale = 0.125f;

	dome[10].x = 580;
	dome[10].y = 202;
	dome[10].scale = 0.1f;
	*/
	for(int i = 0; i < 25; i++)
	{
		dome[i].brightness = 1.0f;
		dome[i].fStamp = 0;
		for(int b = 0; b < 3; b++)
		{
			dome[i].col[b] = rnd() * 1.0f;
			dome[i].old[b] = rnd() * 1.0f;
			dome[i].fade[b] = rnd() * 1.0f;
		}
	}

	for(int i = 0; i < 8; i++)
		domeOrder[i] = 0;

}

//hello, my name is bigbear. i enjoy long walks in the woods and salmon.
void Mobile::update(int timePassed, bool m1, bool m2, bool m3, bool dnp)
{
	
	LightDupeHack();

	UpdateTick(timePassed);
	
	CheckSensors(timePassed, m1, m2, m3, dnp);

	SecondTimer();
	
	SuperAwesomeLightShow();

	MiniEvents();

	DupeLights();

}

//there are 2 lights per planet and 5 in the sun, so we simply dupe them after processing
//Once they're drawn, but before we process the next step, need to set scale to 0 so
// that they are not wastefully processed again
void Mobile::LightDupeHack()
{
	
	for(int a = 8; a < 25; a++)
	{
		dome[a].scale = 0;
	}

}

//magic number time. who gives a shit? not me
void Mobile::DupeLights()
{
	for(int a = 18; a < 25; a++)
	{
		dome[a] = dome[0];
	}
	for(int a = 8; a < 18; a++)
	{
		dome[a] = dome[a - 7];
	}
}

void Mobile::MiniEvents()
{
	int a;
	//domes can randomly go "rapid color change mode" in any idle state
	if(tickcount > nextRapid && curState == 0)
	{
		nextRapid = tickcount + 30000 + (int)(rnd() * 200000.0f);
		a = rand() % 8;
		dome[a].rapid = true;
		dome[a].stopRapidAtTick = tickcount + 2000 + (int)(rnd() * 3000);
		for(int b = 0; b < 3; b++)
		{
			dome[a].col[b] = rnd();
		}
		return;
	}
}

//no lights were harmed in the making of this function
void Mobile::SuperAwesomeLightShow()
{
	switch(curState)
	{
	case 0:
		FadeDomes(1.0f);
		break;
	case 1:
		IdleEvent1(speed);
		break;
	case 2:
		FadeDomes(speed);
		IdleEvent2();
		break;
	case 3:
		FadeDomes(speed);
		break;
	case 4:
		IdleEvent1(speed);
		break;
	case 5:
		if(DNP)
			DoNotPush(numSensors);
		else
			SensorMode(numSensors);
		break;
	case 6:
		if(tickcount - lastIdleEvent > 15000)
			StartIdleState(0);
		break;
	default:
		FadeDomes(1.0f);
		break;
	}
}

void Mobile::DoNotPush(int n)
{

	if(tickcount - highlightStamp > 300)
	{
		highlightStamp = tickcount;
		sensorTime -= 1;
	}

	if(tickcount - lastIdleEvent > 30000)
	{
		curState = 6;
		lastIdleEvent = tickcount;
		for(int a = 0; a < 8; a++)
		{
			dome[a].brightness = 0.0f;
		}
	}
		
	if(tickcount - sensorTimeStamp > sensorTime)
	{

		sensorTimeStamp = tickcount;

		if(n == 3) //cop sirens
		{
			for(int a = 0; a < 8; a++)
			{
				if(dome[a].col[0] == 1.0f && dome[a].col[2] == 0.13f) // red
				{
					dome[a].col[1] = 1.0f;
					dome[a].col[2] = 1.0f;
				}
				else if(dome[a].col[0] == 1.0f && dome[a].col[2] == 1.0f) // white
				{
					dome[a].col[0] = 0.13f;
					dome[a].col[1] = 0.13f;
					dome[a].col[2] = 1.0f;
				}
				else if(dome[a].col[0] == 0.13f && dome[a].col[2] == 1.0f) // blue
				{
					dome[a].col[0] = 1.0f;
					dome[a].col[1] = 0.13f;
					dome[a].col[2] = 0.13f;
				}
			}
		}
		else
		{
			for(int a = 0; a < 8; a++)
			{
				if(dome[a].col[2] == 1.0f && dome[a].col[1] == 1.0f) // if white, turn purple
				{
					dome[a].col[0] = 0.5f;
					dome[a].col[1] = 0.0f;
					dome[a].col[2] = 1.0f;
				}
				else if(dome[a].col[0] == 0.5f) // if purple, turn green
				{
					dome[a].col[0] = 0.0f;
					dome[a].col[1] = 1.0f;
					dome[a].col[2] = 0.0f;
				}
				else if(dome[a].col[1] == 1.0f && dome[a].col[0] == 0.0f) // if green, turn white
				{
					dome[a].col[0] = 1.0f;
					dome[a].col[1] = 1.0f;
					dome[a].col[2] = 1.0f;
				}
			}
		}
	}

}

void Mobile::SensorMode(int n)
{
	switch(n)
	{
	case 1:
		OneSensor(curHighlight, 3000);
		break;
	case 2:
		TwoSensor();
		break;
	case 3:
		FadeDomes(0.3f);
		ThreeSensor();
		break;
	default:
		curState = 0; //you fucked up somehow
		break;
	}
}

void Mobile::OneSensor(int a, int time)
{
	unsigned int elapsed = tickcount - highlightStamp;
	if(dome[a].scale > 0)
	{
		if(highlightWaxing)
		{
			if(dome[a].brightness < 1.0f)
			{
				dome[a].brightness = 0.25f + (0.75f * ((float)elapsed / (float)time));
			}
			else
			{
				dome[a].brightness = 1.0f;
				highlightWaxing = false;
				highlightStamp = tickcount;
			}
		}
		else
		{
			if(dome[a].brightness > 0.25f)
			{
				dome[a].brightness = 1.0f + (-0.75f * ((float)elapsed / float(time)));
			}
			else
			{
				dome[a].brightness = 0.25f;
				highlightWaxing = true;
				curHighlight++;
				highlightStamp = tickcount;
				if(curHighlight > 7)
				{
					curHighlight = 0;
				}
			}
		}
	}
}

void Mobile::TwoSensor()
{
	if(tickcount - sensorTimeStamp > sensorTime)
	{
		sensorTimeStamp = tickcount;
		sensorTime -= 100;
		if(sensorTime < 300)
			sensorTime = 300;
	}

	for(int a = 0; a < 8; a++)
	{
		OneSensor(a,sensorTime);
	}
}


void Mobile::ThreeSensor()
{
	if(tickcount - sensorTimeStamp > 150)
	{
		sensorTimeStamp = tickcount;
		highlightWaxing = !highlightWaxing;
		for(int a = 0; a < 8; a++)
		{
			if(highlightWaxing)
			{
				dome[a].brightness = 1.0f;
			}
			else
			{
				dome[a].brightness = 0.25f;
			}
		}
	}
}

void Mobile::SecondTimer()
{
	int a;
	if(tickcount > secondTimer)
	{
		secondTimer = tickcount + 1000;
		if(curState == 0 && tickcount - lastIdleEvent > 1000)
		{
			if((int)(rnd() * 500) == 7)
			{
				a = (int)(rnd() * 4);
				switch(a)
				{
				case 0:					
					StartIdleEvent1(1);
					break;
				case 1:
					speed = rnd() * 0.8f + 0.2f;
					StartIdleEvent2();
					break;
				case 2:
					speed = rnd() * 0.8f + 0.2f;
					StartIdleState(3);
					break;
				case 3:
					speed = rnd() * 0.4f + 0.2f;
					StartIdleEvent1(4);
					break;
				default:
					break;
				}
			}
		}
	}
}

void Mobile::UpdateTick(int timePassed)
{	
	if(tickcount > 80000000) //overflow protection
	{
		Mobile();
		StartIdleState(0); //this might cause a random abruptness once a day (most likely not) but this may help fix unforseen bugs by resetting values
	}
	else
	{
		tickcount += timePassed;
	}
}

void Mobile::FadeDomes(float factor)
{	
	int elapsed, a;
	if(curState == 3) //are we in an idle event?
	{
		if (tickcount - lastIdleEvent >= 90000.0f) //Has our idle event been going on long enough?
		{
			StartIdleState(0);			
			return;
		}
	}		

	//flicker
	if(tickcount > nextFlick && curState == 0) //is it time to make a random planet flicker?
	{
		nextFlick = tickcount + 30000 + (int)(rnd() * 200000.0f); //this shouldnt happen too often
		a = rand() % 8;
		dome[a].flickering = true;
		dome[a].stopFlickAtTick = (int)(tickcount + 2000.0f + (int)(rnd() * 3000.0f));
		dome[a].flickStamp = tickcount;
		dome[a].flickTime = (int)(rnd() * 50); //randomized flick time looks way cool
		dome[a].flickBrightness = 1.0f; 
		return;
	}

	for(int a = 0; a < 8; a++)
	{
		if(dome[a].scale > 0)
		{

			if(dome[a].flickering == true && curState == 0)
			{
				if(tickcount > dome[a].stopFlickAtTick)
				{
					dome[a].brightness = dome[a].flickBrightness;
					dome[a].flickering = false;
					dome[a].flick = false;
				}
				else
				{
					if(tickcount > dome[a].flickStamp + dome[a].flickTime) //it is time for a new random color				
					{
						dome[a].flick = !(dome[a].flick);
						dome[a].brightness = rnd();
						dome[a].flickTime = (int)(rnd() * 50);
						dome[a].flickStamp = tickcount;
					}				
				}
			}

			if(dome[a].rapid)
			{
				if(tickcount >= dome[a].stopRapidAtTick)
				{
					dome[a].rapid = false;
					return;
				}
				for(int b = 0; b < 3; b++)
				{
					dome[a].col[b] = rnd();
				}
			}
			else
			{				
				if(tickcount > dome[a].fStamp + dome[a].fTime) //it is time for a new random color
				{
					dome[a].old[0] = dome[a].col[0];
					dome[a].old[1] = dome[a].col[1];
					dome[a].old[2] = dome[a].col[2];
					
					dome[a].fade[0] = rnd();
					dome[a].fade[1] = rnd();
					dome[a].fade[2] = rnd();
					dome[a].fTime = (int)(3000.0f * factor + (rnd() * 2000.0f * factor)); //randomize how long to take on new fade
					dome[a].fStamp = tickcount;
				}
				else
				{
					for(int b = 0; b < 3; b++)
					{
						if(dome[a].col[b] != dome[a].fade[b])
						{
							elapsed = tickcount - dome[a].fStamp;
							dome[a].col[b] = dome[a].old[b] + ((dome[a].fade[b] - dome[a].old[b]) * ((float)elapsed / (float)dome[a].fTime)); //fade to color proportional to time passed
							if(dome[a].col[b] < 0)
								dome[a].col[b] = 0;
							if(dome[a].col[b] > 1.0f)
								dome[a].col[b] = 1.0f;
						}
					}
				
				}
			}
		}
	}

}

void Mobile::StartIdleState(int newState)
{
	if(newState == 3)
		speed = (rnd() * 0.6f) + 0.2f;

	nextRapid = tickcount + 30000 + (int)(rnd() * 20000.0f);
	nextFlick = tickcount + 30000 + (int)(rnd() * 20000.0f);

	DNP = false;

	curState = newState;
	lastIdleEvent = tickcount;
	for(int a = 0; a < 8; a++)
	{
		dome[a].brightness = 1.0f;
		dome[a].oldbrightness = 1.0f;
		dome[a].newbrightness = 1.0f;
		dome[a].flickering = false;
		dome[a].flickStamp = 0;
		dome[a].flickTime = 0;
		dome[a].flick = false;
		dome[a].rapid = false;
		
		dome[a].fStamp = 0;
		for(int b = 0; b < 3; b++)
		{
			dome[a].col[b] = rnd() * 1.0f;
			dome[a].old[b] = rnd() * 1.0f;
			dome[a].fade[b] = rnd() * 1.0f;
		}
	}
}

void Mobile::StartIdleEvent1(int newState)
{

	curState = newState;
	lastIdleEvent = tickcount;
	dome[0].brightness = .3f;
	dome[0].oldbrightness = 0.0f;
	dome[0].newbrightness = 0.0f;
	dome[0].flickering = false;
	
	if(newState == 1)
		speed = rnd() * 0.8f + 0.2f;
	else if(newState == 4)
		speed = rnd() * 0.4f + 0.2f;

	dome[0].flick = false;
	dome[0].dimStamp = 0;
	//dome[0].col[0] = rnd() * 1.0f;
	//dome[0].col[1] = rnd() * 1.0f;
	//dome[0].col[2] = rnd() * 1.0f;
	for(int b = 1; b < 8; b++)
	{
		dome[b].dimStamp = tickcount;
		dome[b].dimTime = (int)(2000 * speed + (rnd() * 2000 * speed));
		dome[b].oldbrightness = 1.0f;
		dome[b].newbrightness = 0;
		dome[b].flickering = false;
		dome[b].flick = false;
		dome[b].dimStamp = 0;
		//dome[b].col[0] = rnd() * 1.0f;
		//dome[b].col[1] = rnd() * 1.0f;
		//dome[b].col[2] = rnd() * 1.0f;	
	}
}
	       
void Mobile::StartIdleEvent2()
{
	speed = rnd() * 0.8f + 0.2f;
	curState = 2;
	lastIdleEvent = tickcount;
	hackFlag = false;
}

void Mobile::IdleEvent1(float factor)
{
	int r = 0;
	bool foundDome = false;
	int tries = 0;

	if(tickcount - lastIdleEvent >= 60000.0f)
	{
		StartIdleState(0);
		return;
	}

	if((tickcount - lastIdleEvent) > (2000.0f * factor) && tickcount > (dimStamp + dimTime))
	{
		dimStamp = tickcount;
		dimTime = (int)((3500.0f * factor) + (rnd() * 4500.0f * factor));

		while(foundDome == false)
		{
			r = (int)(rnd() * 7) + 1;
			tries += 1;
			if(dome[r].scale > 0 && dome[r].brightness == 0)
			{
				foundDome = true;
				dome[r].newbrightness = 1.0f;
				dome[r].dimOutAtTick = 0;
				dome[r].oldbrightness = 0;
				dome[r].dimStamp = tickcount;
				dome[r].dimTime = (int)(2000.0f * factor + (rnd() * 2000.0f * factor));
			}
			if(tries >= 60)
			{
				foundDome = true;
				StartIdleState(0);
				return;
			}
		}
	}

	for(int a = 1; a < 8; a++)
	{
		if(dome[a].scale > 0)
		{
			if(dome[a].brightness != dome[a].newbrightness)
			{
				dome[a].brightness = dome[a].oldbrightness + ((dome[a].newbrightness - dome[a].oldbrightness) * ((float)(tickcount - dome[a].dimStamp) / (float)dome[a].dimTime));
				if(dome[a].brightness > 1.0f)
					dome[a].brightness = 1.0f;
				if(dome[a].brightness < 0)
					dome[a].brightness = 0;
			}
			else if(dome[a].brightness == 1.0f)
			{
				if(dome[a].dimOutAtTick == 0)
				{
					dome[a].dimOutAtTick = tickcount + (int)(rnd() * 3500.0f * factor);
				}
				else if(tickcount >= dome[a].dimOutAtTick)
				{
					dome[a].oldbrightness = 0.99f;
					dome[a].newbrightness = 0.0f;
					dome[a].brightness = 0.99f;
					dome[a].dimStamp = tickcount;
					dome[a].dimTime = (int)(2000.0f * factor + (rnd() * 2000.0f * factor));
					dome[a].dimOutAtTick = 0;
				}
			}
		}
	}

}

void Mobile::IdleEvent2()
{
	int a;
	int tries = 0;
	bool found = false;

	if(hackFlag && tickcount - lastIdleEvent > 2000)
	{
		StartIdleState(0);
		return;
	}

	if(tickcount < lastIdleEvent + 4000)
		return;

	if(tickcount > dimStamp + dimTime)
	{
		dimStamp = tickcount;
		dimTime = (int)(4500.0f * speed + (int)(rnd() * 3500.0f * speed));
		
		while(found != true)
		{
			a = (int)(rnd() * 8);
			tries += 1;
			if(dome[a].scale > 0 && dome[a].brightness > 0 && dome[a].flickering == false)
			{
				found = true;
				dome[a].flickering = true;
				dome[a].flickStamp = tickcount;
				dome[a].flickTime = (int)(rnd() * 50);
				dome[a].flickBrightness = 0;
				dome[a].stopFlickAtTick = (int)(tickcount + (3000.0f * speed) + (int)(rnd() * 3000.0f * speed));				
			}

			if(tries > 60)
			{
				found = true;
			}
		}
	}

	int count = 0;
	for(int a = 0; a < 8; a++)
	{
		if(dome[a].scale > 0 && dome[a].brightness > 0)
		{
			count++;
		}
	}
	if(count==0)
	{
		hackFlag = true;
		lastIdleEvent = tickcount;
	}

	for(int a = 0; a < 8; a++)
	{
		if(dome[a].scale > 0 && dome[a].flickering == true)
		{
			if(tickcount > dome[a].stopFlickAtTick)
			{
				dome[a].brightness = 0.0f;
				dome[a].flickering = false;
			}
			else
			{
				if(tickcount > dome[a].flickStamp + dome[a].flickTime) //it is time for a new random color				
				{
					dome[a].flick = !(dome[a].flick);
					dome[a].brightness = rnd();
					dome[a].flickTime = (int)(rnd() * 50);
					dome[a].flickStamp = tickcount;
				}				
			}
		}
	}
}

void Mobile::StartSensorState()
{

	int a, b;

	lastIdleEvent = 0;
	curState = 5;
	highlightStamp = tickcount + 1000;
	highlightWaxing = true;
	sensorTime = 3000;
	sensorTimeStamp = tickcount;
	curHighlight = 0; //not which dome, but rather which cell of domeOrder we are working with
	
	//pick a random order for domes to light up in
	for(a = 0; a < 25; a++)
	{
		dome[a].selected = false;
		dome[a].flick = false;
		dome[a].rapid = false;
	}

	for(a = 0; a < 8; a++)
	{
		do
		{
			b = (int)(rnd() * 8);
		} while(dome[b].selected == true);
		domeOrder[a] = b;
		dome[b].selected = true;
	}

	//now domeOrder should contain all the domes exactly once

	for(a = 0; a < 8; a++)
	{
		dome[a].brightness = 0.25f;
		dome[a].newbrightness = 0.25f;
		dome[a].oldbrightness = 0.25f;
	}

}

void Mobile::StartDNP()
{

	curState = 5;
	sensorTime = 100;
	highlightStamp = tickcount;
	sensorTimeStamp = tickcount;
	lastIdleEvent = tickcount;

	for(int a = 0; a < 8; a++)
	{
		if(a % 3 == 0)
		{
			dome[a].col[0] = 1.0f;
			dome[a].col[1] = 1.0f;
			dome[a].col[2] = 1.0f;
		}
		else if (a % 3 == 1)
		{
			dome[a].col[0] = 1.0f;
			dome[a].col[1] = 1.0f;
			dome[a].col[2] = 1.0f;
		}
		else
		{
			dome[a].col[0] = 1.0f;
			dome[a].col[1] = 1.0f;
			dome[a].col[2] = 1.0f;
		}
		dome[a].flickering = false;
		dome[a].flick = false;
		dome[a].brightness = 1.0f;
		dome[a].rapid = false;
	}

}

void Mobile::CheckSensors(int timePassed, bool m1, bool m2, bool m3, bool m4)
{
	
	if(m4)
	{
		if(!DNP)
		{
			DNP = true;
			StartDNP();
		}
	}
	
	if(DNP)
		return;

	for(int b = 0; b < 3; b++)
	{
		if(mTimer[b] > 0)
		{
			mTimer[b] -= timePassed;
			if(mTimer[b] < 0)
			{
				mTimer[b] = 0;
				m[b] = false;
			}
		}
	}
	
	prevNumSensors = numSensors;
	numSensors = 0;

	if(m1 || mTimer[0] > 0)
	{
		numSensors++;
		m[0] = true;
	}
	else
		if(m[0] && mTimer[0] == 0)
			mTimer[0] = SENSOR_BUFFER;
		else
			m[0] = false;

	if(m2 || mTimer[1] > 0)
	{
		numSensors++;
		m[1] = true;
	}
	else
		if(m[1] && mTimer[1] == 0)
			mTimer[1] = SENSOR_BUFFER;
		else
			m[1] = false;

	if(m3 || mTimer[2] > 0)
	{
		numSensors++;
		m[2] = true;
	}
	else
		if(m[2] && mTimer[2] == 0)
			mTimer[2] = SENSOR_BUFFER;
		else
			m[2] = false;

	
	if (numSensors > 0)
	{
		
		if(prevNumSensors == 0)
		{
			mTimer[0] = 30000;
			StartSensorState();
			return;
		}
		if(numSensors > 0 && numSensors != prevNumSensors) //when changing between 1,2,3 sensors, reset shiz
		{
			sensorTime = 3000;
			sensorTimeStamp = tickcount;
			for(int i = 0; i < 8; i++)
			{
				dome[i].brightness = 0.25f;
				dome[i].oldbrightness = 0.25f;
				dome[i].newbrightness = 0.25f;
			}
		}
	}
	else if(prevNumSensors > 0)
	{
		StartIdleState(0);
		numSensors = 0;
		prevNumSensors = 0;
		lastIdleEvent = tickcount;
		m[0] = false;
		m[1] = false;
		m[2] = false;
		mTimer[0] = 0; //I have no idea why I had to put these in, but it fixed a bug
		mTimer[1] = 0; //Without resetting the timers, it was calling StartSensorState() before setting to idle state. weird, right?
		mTimer[2] = 0; //hambone, HAMBONE
	}

}