#include "EI_Mobile.h"
#include <stdlib.h>
#include <GL/glut.h>//This header file contains all the commands for the OpenGL Utility Toolkit
#include <time.h>
#include <Windows.h>
#include <iostream>
#include <conio.h>

DWORD tick = 0;

Mobile mobile;
void idle();
void init();
void display();

int main(int argc, char ** argv)
{

	printf("Hi, Space Cadet!\n");
	printf("F1 - Main Idle State\n");
	printf("F2 - Idle event 1\n");
	printf("F3 - Idle event 2\n");
	printf("F4 - Idle event 3\n");
	printf("F5 - Idle event 4\n");
	printf("Keys only recognized in the console, not the space window.\n");

	tick = GetTickCount();
	srand(time(NULL));
	mobile.StartIdleState(0);
	glutInit(&argc, argv);
	glutInitWindowSize(800,700);
	glutInitWindowPosition(300,0);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA | GLUT_ALPHA);
	glutCreateWindow("EI");
	init();
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	glutMainLoop();
	return 0;
}


void idle()
{
	if(GetAsyncKeyState(49) & 0x8000)
		mobile.keys[0] = true;
	else
		mobile.keys[0] = false;
	if(GetAsyncKeyState(50) & 0x8000)
		mobile.keys[1] = true;
	else
		mobile.keys[1] = false;
	if(GetAsyncKeyState(51) & 0x8000)
		mobile.keys[2] = true;
	else
		mobile.keys[2] = false;
	if(GetAsyncKeyState(52) & 0x8000)
		mobile.keys[3] = true;
	else
		mobile.keys[3] = false;


	char ch;
	if (_kbhit())
    {
		// in case of a key is hit, do these
		ch = _getch();
		switch((int)ch)
		{
		case 59:
			printf("Main idle state\n");
			mobile.StartIdleState(0);
			break;
		case 60:
			printf("Idle state 1\n");
			mobile.StartIdleEvent1(1);
			break;
		case 61:
			printf("Idle state 2\n");
			mobile.StartIdleEvent2();
			break;
		case 62:
			printf("Idle state 3\n");
			mobile.StartIdleState(3);
			break;
		case 63:
			printf("Idle state 4\n");
			mobile.StartIdleEvent1(4);
			break;
		}
	}
}



void init()
{

	glClearColor(0,0,0,0);
	glMatrixMode(GL_PROJECTION); 
    glMatrixMode(GL_MODELVIEW); 
	gluOrtho2D(-5,5,-5,5);
	glEnable (GL_BLEND);
	glBlendFunc (GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

}

void drawcircle(float x, float y, float radius)
{

	//x -= 512;
	//y -= 512;
	radius /= 8.0f;
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
    glTranslatef(x / 800.0f, y / 700.0f, 0.0f);
    static const int circle_points = 200;
    static const float angle = 2.0f * 3.1416f / circle_points;

    glBegin(GL_POLYGON);
    double angle1=0.0;
    glVertex2d(radius * cos(0.0) , radius * sin(0.0));

    for(int i = 0; i < circle_points; i++)
    {       
        glVertex2d(radius * cos(angle1), radius *sin(angle1));
        angle1 += angle;
    }
    glEnd();
    glPopMatrix();

}

void display()
{

	mobile.update(GetTickCount() - tick, mobile.keys[0], mobile.keys[1], mobile.keys[2], mobile.keys[3]);
	tick = GetTickCount();

	glClear(GL_COLOR_BUFFER_BIT);

	//Draw domes
	for(int i = 0; i < 25; i++)
	{
		if(mobile.dome[i].scale > 0 && (mobile.dome[i].flick == false))
		{
			//printf("R: %f, G: %f, B: %f, A: %f",mobile.dome[i].col[0], mobile.dome[i].col[1], mobile.dome[i].col[2], mobile.dome[i].brightness);
			glColor4f(mobile.dome[i].col[0], mobile.dome[i].col[1], mobile.dome[i].col[2], mobile.dome[i].brightness);
			drawcircle(mobile.dome[i].x, mobile.dome[i].y, mobile.dome[i].scale);
		}
	}

	glutSwapBuffers();
	glutPostRedisplay();

}
